package wusthelper;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

@EnableAsync
@EnableScheduling
@EnableFeignClients(basePackages = {"cn.wustlinghang.wusthelper.web.rpc"})
@SpringBootApplication(scanBasePackages = {
        // 指定springboot的bean扫描路径，有新增请及时更新
        "cn.wustlinghang.wusthelper.data",
        "cn.wustlinghang.wusthelper.web",
})
@MapperScan("cn.wustlinghang.wusthelper.data.dao.mapper")
public class WebBackendMain {
    public static void main(String[] args) {
        SpringApplication.run(WebBackendMain.class);
    }
}
