package wusthelper.web.api.v2.undergrade;

import org.springframework.web.bind.annotation.*;
import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import wusthelper.web.api.v2.Token;
import wusthelper.web.response.Response;
import wusthelper.web.service.campus.GeneralUserService;
import wusthelper.web.service.campus.undergrad.UndergradCookieService;

@RestController
@RequestMapping("/jwc")
public class UndergradLoginController {
    private final GeneralUserService generalUserService;

    public UndergradLoginController(GeneralUserService generalUserService) {
        this.generalUserService = generalUserService;
    }

    @PostMapping("/login")
    public Response<String> login(@RequestParam(value = "username") String username,
                                  @RequestParam(value = "jwcPwd") String password,
                                  @RequestHeader(name = "Platform", required = false) String platform) {

        var user = generalUserService.login(username, password, GeneralUserService.UserType.Undergrad);

        String token = Token.signToken(user.getId(), user.getStuNum());

        return Response.success(token);
    }
}