package wusthelper.web.configure;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import wusthelper.web.util.PasswordCodec;

@Configuration
public class PasswordCodecConfigure {
    private final GlobalConfigureItems globalConfigureItems;

    public PasswordCodecConfigure(GlobalConfigureItems globalConfigureItems) {
        this.globalConfigureItems = globalConfigureItems;
    }

    @Bean
    public PasswordCodec passwordCodec() {
        String key = globalConfigureItems.getPasswordEncodeKey();

        return new PasswordCodec(key);
    }
}
