package wusthelper.web.data.entity;

import java.util.StringJoiner;

public enum CookieType {
    Undergrad(0, "本科生"),
    Graduate(1, "研究生"),
    Library(2, "图书馆"),
    Physics(3, "物理实验"),;

    private final int code;

    private final String message;

    CookieType(int id, String describe) {
        this.code = id;
        this.message = describe;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", CookieType.class.getSimpleName() + "[", "]")
                .add("code=" + code)
                .add("message='" + message + "'")
                .toString();
    }
}