package wusthelper.web.rpc.graduate;

import cn.wustlinghang.mywust.data.global.StudentInfo;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import wusthelper.internal.rpc.response.RpcResponseDto;

@FeignClient(name = "wusthelper.graduate", contextId = "studentInfo")
public interface GraduateStudentInfoRemote {
    String ROOT_PATH = "/student_info";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<StudentInfo> get(@RequestParam("cookie") String cookie);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<StudentInfo> parse(String html);
}
