package wusthelper.web.rpc.undergrad;

import cn.wustlinghang.mywust.data.global.Course;
import wusthelper.internal.rpc.response.RpcResponseDto;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "wusthelper.undergrad", contextId = "courseTable")
public interface CourseTableRemote {
    String ROOT_PATH = "/course_table";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<List<Course>> get(@RequestParam("cookie") String cookie,
                                     @RequestParam("term") String term);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie,
                                 @RequestParam("term") String term);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<List<Course>> parse(String html);
}
