package wusthelper.web.rpc.undergrad;

import wusthelper.internal.rpc.response.RpcResponseDto;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "wusthelper.undergrad", contextId = "creditStatus")
public interface CreditStatusRemote {
    String ROOT_PATH = "/credit_status";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<String> get(@RequestParam("cookie") String cookie);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<String> parse(String html);
}
