package wusthelper.web.rpc.undergrad;

import cn.wustlinghang.mywust.data.undergrad.ExamDelayApplication;
import wusthelper.internal.rpc.response.RpcResponseDto;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "wusthelper.undergrad", contextId = "examDelayApplication")
public interface ExamDelayApplicationRemote {
    String ROOT_PATH = "/exam_delay_application";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<ExamDelayApplication> get(@RequestParam("cookie") String cookie,
                                             @RequestParam("term") String term,
                                             @RequestParam("activity_id") String activityId);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie,
                                 @RequestParam("term") String term,
                                 @RequestParam("activity_id") String activityId);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<ExamDelayApplication> parse(String html);
}
