package wusthelper.web.rpc.undergrad;

import wusthelper.internal.rpc.response.RpcResponseDto;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "wusthelper.undergrad", contextId = "cookie")
public interface UndergradCookieRemote {
    String COOKIE_ROOT_PATH = "/cookie";

    @GetMapping(COOKIE_ROOT_PATH)
    RpcResponseDto<String> login(@RequestParam("username") String username,
                                 @RequestParam("password") String password);

    @GetMapping(COOKIE_ROOT_PATH + "/verify")
    RpcResponseDto<Boolean> verify(@RequestParam("cookie") String cookie);
}
