package wusthelper.web.service.campus.undergrad;

import wusthelper.code.ServiceCode;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.undergrad.CreditStatusRemote;
import wusthelper.web.service.cookie.CookieManager;
import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import org.springframework.stereotype.Service;

@Service
public class CreditStatusService {
    private final CreditStatusRemote creditStatusRemote;
    private final CookieManager cookieManager;

    public CreditStatusService(CreditStatusRemote creditStatusRemote, CookieManager cookieManager) {
        this.creditStatusRemote = creditStatusRemote;
        this.cookieManager = cookieManager;
    }

    public String getCreditStatus(String user) {
        String cookie = cookieManager.getCookie(user, CookieType.Undergrad);
        var rpcResp = creditStatusRemote.get(cookie);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.of(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
