package wusthelper.web.service.campus.undergrad;

import wusthelper.code.ServiceCode;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.undergrad.ExamDelayApplicationRemote;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.service.cookie.CookieManager;
import cn.wustlinghang.mywust.data.undergrad.ExamDelayApplication;
import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import org.springframework.stereotype.Service;

@Service
public class ExamDelayApplicationService {
    private final ExamDelayApplicationRemote examDelayApplicationRemote;
    private final CookieManager cookieManager;

    public ExamDelayApplicationService(ExamDelayApplicationRemote examDelayApplicationRemote,
                                       CookieManager cookieManager) {
        this.examDelayApplicationRemote = examDelayApplicationRemote;
        this.cookieManager = cookieManager;
    }

    public ExamDelayApplication getExamDelayApplication(String user, String term, String activityId) {
        String cookie = cookieManager.getCookie(user, CookieType.Undergrad);
        var rpcResp = examDelayApplicationRemote.get(cookie, term, activityId);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.of(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
