package wusthelper.web.service.campus.undergrad;

import wusthelper.code.ServiceCode;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.undergrad.ScoreRemote;
import wusthelper.web.service.cookie.CookieManager;
import cn.wustlinghang.mywust.data.global.Score;
import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ScoreService {
    private final ScoreRemote scoreRemote;
    private final CookieManager cookieManager;

    public ScoreService(ScoreRemote scoreRemote, CookieManager cookieManager) {
        this.scoreRemote = scoreRemote;
        this.cookieManager = cookieManager;
    }

    public List<Score> getScore(String user) {
        String cookie = cookieManager.getCookie(user, CookieType.Undergrad);
        var rpcResp = scoreRemote.get(cookie);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.of(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
