package wusthelper.web.service.campus.undergrad;

import wusthelper.code.ServiceCode;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.undergrad.TrainingPlanRemote;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.service.cookie.CookieManager;
import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import org.springframework.stereotype.Service;

@Service
public class TrainingPlanService {
    private final TrainingPlanRemote trainingPlanRemote;
    private final CookieManager cookieManager;

    public TrainingPlanService(TrainingPlanRemote trainingPlanRemote, CookieManager cookieManager) {
        this.trainingPlanRemote = trainingPlanRemote;
        this.cookieManager = cookieManager;
    }

    public String getTrainingPlan(String user) {
        String cookie = cookieManager.getCookie(user, CookieType.Undergrad);
        var rpcResp = trainingPlanRemote.get(cookie);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.of(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
