package wusthelper.web.service.campus.undergrad;

import org.springframework.stereotype.Service;
import wusthelper.code.ServiceCode;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.undergrad.UndergradCookieRemote;

@Service
public class UndergradCookieService {

    private final UndergradCookieRemote undergradCookieRemote;

    public UndergradCookieService(UndergradCookieRemote undergradCookieRemote) {
        this.undergradCookieRemote = undergradCookieRemote;
    }

    public String getLoginCookie(String username, String password) throws ServiceException {
        var rpcResp = undergradCookieRemote.login(username, password);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.of(rpcResp.code());
        }

        return rpcResp.data();
    }

    public Boolean checkCookie(String cookie) {
        return undergradCookieRemote.verify(cookie).data();
    }
}
