package wusthelper;

import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.test.context.TestPropertySource;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import wusthelper.web.api.v2.Token;

@Slf4j
@EnableAsync
@Configuration
@EnableScheduling
@ExtendWith(SpringExtension.class)
@EnableFeignClients(basePackages = {"wusthelper.web.rpc"})
@TestPropertySource(properties = {
        "spring.config.location=classpath:application-test.yml"
})
@SpringBootApplication(scanBasePackages = {
        // 指定springboot的bean扫描路径，有新增请及时更新
        "wusthelper.data",
        "wusthelper.web",
})
@MapperScan("cn.wustlinghang.wusthelper.data.dao.mapper")
public class TestMain {
    @Test
    public void jwtTest() {
        String token = Token.signToken(1233487L, "202118194039");
        log.info(token);
    }

    public static void main(String[] args) {
        String token = Token.signToken(1233487L, "202118194039");
        boolean valid = Token.verifyToken(token);
        var uid = Token.getUid(token);
        var studentNumber = Token.getStudentNumber(token);
        log.info(token);
        log.info("{}", valid);
        log.info(uid);
        log.info(studentNumber);
    }
}
