package wusthelper.internal.rpc.response;

import com.fasterxml.jackson.annotation.JsonInclude;

@JsonInclude(JsonInclude.Include.NON_NULL)
public record RpcResponseDto<T>(int code, T data) {
    public static <T> RpcResponseDto<T> success(T data) {
        return new RpcResponseDto<>(RpcCommonResponseCode.Success.getCode(), data);
    }

    public static <T> RpcResponseDto<T> success() {
        return success(null);
    }

    public static <T> RpcResponseDto<T> error(int code, String message) {
        return new RpcResponseDto<>(code, null);
    }

    public static <T> RpcResponseDto<T> error(RpcCommonResponseCode code) {
        return error(code.getCode(), code.getMessage());
    }
}