package wusthelper.web.exception;

import wusthelper.code.ServiceCode;

public class ServiceException extends RuntimeException {
    private final int code;

    public ServiceException(ServiceCode code) {
        this(code, code.getDescription());
    }

    public ServiceException(ServiceCode code, String message) {
        super(message);
        this.code = code.getCode();
    }

    public ServiceException(int code) {
        this(code, ServiceCode.getDescribe(code));
    }

    public ServiceException(int code, String message) {
        super(message);
        this.code = code;
    }

    public ServiceCode getCode() {
        return ServiceCode.of(code);
    }

    public int getCodeValue() {
        return code;
    }

    /**
     * 直接按错误码抛出异常
     *
     * @param code 错误码
     * @throws ServiceException .
     */
    public static void of(int code) throws ServiceException {
        throw new ServiceException(code);
    }
}
