package wusthelper.internal.graduate.api.http.v1.handler;

import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import jakarta.validation.ValidationException;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Provider
public class ValidationExceptionHandler extends BaseExceptionHandler
        implements ExceptionMapper<ValidationException> {
    @Override
    public Response toResponse(ValidationException e) {
        return super.toResponse(
                RpcCommonResponseCode.ParamWrong,
                "参数错误：" + e.toString(),
                "ValidationExceptionHandler"
        );
    }
}
