package wusthelper.internal.graduate.api.http.v1.handler;

import wusthelper.internal.rpc.exception.GraduateRpcException;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.ws.rs.WebApplicationException;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class WebApplicationExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<WebApplicationException> {
    @Override
    public Response toResponse(WebApplicationException e) {
        return super.toResponse(
                e.getResponse().getStatus(),
                RpcException.toIntCode(
                        GraduateRpcException.GRADUATE_MODULE,
                        GraduateRpcException.SubModuleCode.COMMON.ordinal(),
                        GraduateRpcException.TypeCode.OTHER_EXCEPTION.ordinal() * 100
                                + GraduateRpcException.ErrorCode.REQUEST_INVALID.ordinal()
                ),
                e.getMessage(),
                "WebApplicationExceptionHandler"
        );
    }
}
