package wusthelper.internal.graduate.rpc.config;

import jakarta.inject.Singleton;
import jakarta.ws.rs.DefaultValue;
import lombok.Data;
import org.eclipse.microprofile.config.inject.ConfigProperty;

@Data
@Singleton
public class RpcConfig {
    @DefaultValue("default.service")
    @ConfigProperty(name = "rpc.service.name")
    String serviceName;

    @DefaultValue("http://127.0.0.1:8500")
    @ConfigProperty(name = "rpc.register.consul-api.address")
    String consulAddress;

    @DefaultValue("http://127.0.0.1:7400")
    @ConfigProperty(name = "rpc.frpc.admin-api.address")
    String frpcAdminAddress;

    @DefaultValue("")
    @ConfigProperty(name = "rpc.frpc.admin.username")
    String frpcAdminUsername;

    @DefaultValue("")
    @ConfigProperty(name = "rpc.frpc.admin.password")
    String frpcAdminPassword;

    @ConfigProperty(name = "quarkus.http.port")
    String localServicePort;
}
