package wusthelper.internal.graduate.services;

import cn.wustlinghang.mywust.exception.ApiException;
import wusthelper.internal.rpc.exception.GraduateRpcException;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public abstract class BaseService {
    protected GraduateRpcException wrapApiException(ApiException e, GraduateRpcException.SubModuleCode subModuleCode) {
        return switch (e.getCode()) {
            case NETWORK_EXCEPTION -> new GraduateRpcException(
                    GraduateRpcException.TypeCode.NETWORK_EXCEPTION,
                    subModuleCode,
                    GraduateRpcException.ErrorCode.NETWORK_ERROR
            );
            case COOKIE_INVALID -> new GraduateRpcException(
                    GraduateRpcException.TypeCode.AUTH_EXCEPTION,
                    subModuleCode,
                    GraduateRpcException.ErrorCode.COOKIE_INVALID
            );
            default -> {
                log.error("研究生：{}代理请求异常，异常未处理", subModuleCode.name());
                log.error("异常：", e);
                yield new GraduateRpcException(
                        GraduateRpcException.TypeCode.AUTH_EXCEPTION,
                        subModuleCode,
                        GraduateRpcException.ErrorCode.COOKIE_INVALID
                );
            }
        };
    }
}
