package wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.mywust.data.library.parsed.BookHolding;
import wusthelper.internal.library.services.BookHoldingService;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/holdings")
@ApplicationScoped
public class BookHoldingApi {
    private final BookHoldingService service;

    public BookHoldingApi(BookHoldingService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<BookHolding> get(@QueryParam("id") @NotNull String id)
            throws RpcException {
        return this.agent(id);
    }

    @GET
    @Path("/agent")
    public List<BookHolding> agent(@QueryParam("id") @NotNull String id)
            throws RpcException {
        return service.getHoldings(id);
    }
}
