package wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.BookSearchResult;
import wusthelper.internal.library.services.SearchService;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.DefaultValue;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/search")
@ApplicationScoped
public class SearchApi {
    private final SearchService service;

    public SearchApi(SearchService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public PagingResult<List<BookSearchResult>> get(
            @QueryParam("keyword") @NotNull String keyword,
            @DefaultValue("1") @QueryParam("page") int page,
            @DefaultValue("20") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return this.agent(keyword, page, pageSize);
    }

    @GET
    @Path("/agent")
    public PagingResult<List<BookSearchResult>> agent(
            @QueryParam("keyword") @NotNull String keyword,
            @DefaultValue("1") @QueryParam("page") int page,
            @DefaultValue("20") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return service.search(keyword, page, pageSize);
    }
}
