package wusthelper.internal.library.api.http.v1.handler;

import cn.wustlinghang.mywust.exception.ParseException;
import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Provider
public class ParseExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<ParseException> {
    @Override
    public Response toResponse(ParseException e) {
        log.error("解析异常：", e);
        return super.toResponse(
                RpcCommonResponseCode.ServerInternalError,
                e.toString(),
                "ParseExceptionHandler"
        );
    }
}
