package wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.BookDetailApiService;
import cn.wustlinghang.mywust.data.library.parsed.BookDetail;
import cn.wustlinghang.mywust.exception.ApiException;
import wusthelper.internal.rpc.exception.LibraryRpcException;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class BookDetailService extends BaseService {
    private final BookDetailApiService api;

    public BookDetailService(BookDetailApiService api) {
        this.api = api;
    }

    public BookDetail getBookDetail(String bookId) throws RpcException {
        try {
            return api.getBookDetail(bookId);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.BOOK_DETAIL);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.BOOK_DETAIL,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }

}
