package wusthelper.internal.physics.bean;

import cn.wustlinghang.mywust.core.request.service.auth.PhysicsLogin;
import cn.wustlinghang.mywust.core.request.service.physics.PhysicsCourseApiService;
import cn.wustlinghang.mywust.core.request.service.physics.PhysicsScoreApiService;
import cn.wustlinghang.mywust.network.RequestClientOption;
import cn.wustlinghang.mywust.network.Requester;
import cn.wustlinghang.mywust.network.okhttp.SimpleOkhttpRequester;
import jakarta.inject.Singleton;

public class MywustRequestAgentBeans {

    @Singleton
    public RequestClientOption requestClientOption() {
        RequestClientOption.Proxy proxy = RequestClientOption.Proxy.builder()
                .address("127.0.0.1")
                .port(8080)
                .build();
        RequestClientOption option = new RequestClientOption();
//        option.setProxy(proxy);

        return option;
    }

    @Singleton
    public Requester requester(RequestClientOption option) {
        return new SimpleOkhttpRequester(option, true);

//        return new SimpleOkhttpRequester(true);
    }

    @Singleton
    public PhysicsLogin physicsLogin(Requester requester) {
        return new PhysicsLogin(requester);
    }

    @Singleton
    public PhysicsCourseApiService physicsCourseApiService(Requester requester) {
        return new PhysicsCourseApiService(requester);
    }

    @Singleton
    public PhysicsScoreApiService physicsScoreApiService(Requester requester) {
        return new PhysicsScoreApiService(requester);
    }
}