package wusthelper.internal.undergrad.api.http.v1;

import wusthelper.internal.undergrad.services.CreditStatusService;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

@Path("/credit_status")
@ApplicationScoped
public class CreditStatusApi {
    private final CreditStatusService service;

    public CreditStatusApi(CreditStatusService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public String get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        String html = this.agent(cookie);
        return this.parse(html);
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return service.getCreditStatus(cookie);
    }

    @POST
    @Path("/parse")
    public String parse(String html) throws RpcException {
        return service.parseCreditStatus(html);
    }
}
