package wusthelper.internal.undergrad.api.http.v1;

import cn.wustlinghang.mywust.data.undergrad.ExamDelayApplication;
import wusthelper.internal.undergrad.services.ExamDelayApplicationService;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/exam_delay_application")
@ApplicationScoped
public class ExamDelayApplicationApi {
    private final ExamDelayApplicationService service;

    public ExamDelayApplicationApi(ExamDelayApplicationService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<ExamDelayApplication> get(
            @QueryParam("cookie") @NotNull String cookie,
            @QueryParam("term") @NotNull String term,
            @QueryParam("activity_id") @NotNull String activityId)
            throws RpcException {
        return this.parse(this.agent(cookie, term, activityId));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie,
                        @QueryParam("term") @NotNull String term,
                        @QueryParam("activity_id") @NotNull String activityId)
            throws RpcException {
        return service.getExamDelayApplications(cookie, term, activityId);
    }

    @POST
    @Path("/parse")
    public List<ExamDelayApplication> parse(String html) throws RpcException {
        return service.parseExamDelayApplications(html);
    }
}
