package wusthelper.internal.undergrad.api.http.v1;

import wusthelper.internal.undergrad.services.TrainingPlanService;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

@Path("/training_plan")
@ApplicationScoped
public class TrainingPlanApi {
    private final TrainingPlanService service;

    public TrainingPlanApi(TrainingPlanService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public String get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return service.getTrainingPlan(cookie);
    }

    @POST
    @Path("/parse")
    public String parse(String html) throws RpcException {
        return service.parseTrainingPlan(html);
    }
}
