package wusthelper.internal.undergrad.api.http.v1.handler;

import wusthelper.internal.rpc.response.RpcCommonResponseCode;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Provider
public class DefaultExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<Exception> {
    @Override
    public Response toResponse(Exception e) {
        log.error("未知异常：", e);
        return super.toResponse(
                RpcCommonResponseCode.ServerInternalError,
                e.toString(),
                "DefaultExceptionHandler"
        );
    }
}
