package wusthelper.internal.undergrad.rpc;

import cn.wustlinghang.mywust.network.Requester;
import wusthelper.internal.rpc.FrpConsulRegister;
import wusthelper.internal.rpc.config.FrpConfig;
import wusthelper.internal.rpc.config.RegisterConfig;
import wusthelper.internal.undergrad.rpc.config.RpcConfig;
import com.fasterxml.jackson.databind.ObjectMapper;
import io.quarkus.runtime.Startup;
import jakarta.annotation.PostConstruct;
import jakarta.enterprise.context.ApplicationScoped;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Startup
@ApplicationScoped
public class Register {

    private final FrpConsulRegister register;

    public Register(RpcConfig rpcConfig, Requester requester, ObjectMapper objectMapper) {
        FrpConfig frpConfig = FrpConfig.builder()
                .frpcAdminAddress(rpcConfig.getFrpcAdminAddress())
                .frpcAdminUsername(rpcConfig.getFrpcAdminUsername())
                .frpcAdminPassword(rpcConfig.getFrpcAdminPassword())
                .build();
        RegisterConfig registerConfig = RegisterConfig.builder()
                .consulAddress(rpcConfig.getConsulAddress())
                .localServicePort(rpcConfig.getLocalServicePort())
                .serviceName(rpcConfig.getServiceName())
                .build();

        this.register = new FrpConsulRegister(registerConfig, frpConfig, requester, objectMapper);
    }

    @PostConstruct
    public void onStartup() {
        register.register();
    }
}
