package wusthelper.internal.undergrad.services;

import cn.wustlinghang.mywust.exception.ApiException;
import wusthelper.internal.rpc.exception.UndergradRpcException;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public abstract class BaseService {
    protected UndergradRpcException wrapApiException(ApiException e, UndergradRpcException.SubModuleCode subModuleCode) {
        return switch (e.getCode()) {
            case NETWORK_EXCEPTION -> new UndergradRpcException(
                    UndergradRpcException.TypeCode.NETWORK_EXCEPTION,
                    subModuleCode,
                    UndergradRpcException.ErrorCode.NETWORK_ERROR
            );
            case COOKIE_INVALID -> new UndergradRpcException(
                    UndergradRpcException.TypeCode.AUTH_EXCEPTION,
                    subModuleCode,
                    UndergradRpcException.ErrorCode.COOKIE_INVALID
            );
            default -> {
                log.error("本科生：{}代理请求异常，异常未处理", subModuleCode.name());
                log.error("异常：", e);
                yield new UndergradRpcException(
                        UndergradRpcException.TypeCode.AUTH_EXCEPTION,
                        subModuleCode,
                        UndergradRpcException.ErrorCode.COOKIE_INVALID
                );
            }
        };
    }
}
