package wusthelper.internal.undergrad.services;

import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradExamDelayApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import wusthelper.internal.rpc.exception.UndergradRpcException;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class ExamActivitiesService extends BaseService {
    private final UndergradExamDelayApiService examDelayApiService;

    public ExamActivitiesService(UndergradExamDelayApiService examDelayApiService) {
        this.examDelayApiService = examDelayApiService;
    }

    public UndergradExamDelayApiService.ExamActivity[] getExamActivities(String cookie, String term)
            throws RpcException {
        try {
            return examDelayApiService.getActivities(term, cookie);
        } catch (ApiException e) {
            throw wrapApiException(e, UndergradRpcException.SubModuleCode.EXAM_ACTIVITIES);
        } catch (IOException e) {
            throw new UndergradRpcException(
                    UndergradRpcException.TypeCode.NETWORK_EXCEPTION,
                    UndergradRpcException.SubModuleCode.EXAM_ACTIVITIES,
                    UndergradRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }

}
